// TODO : Security issues

function DisplayWebUrlElement(ContentElement){
    var self = this; self.name = "DisplayWebUrlElement"; // MANDATORY

    this.reference = -1;
    this.type = -1;
    this.switch = 0;
    this.relative_path = false;
    this.force_http_source = false;
    this.die = true;
    this.time_to_die = 1500;

    this.loaded = false;
    this.load_timeout = 30; // Load timeout in seconds

    this.x = 0;
    this.y = 0;
    this.w = "100%";
    this.h = "100%";
    this.z = 1;

    this.ui = false;
    this.uiTimer = null;
    this.uiStartTime = 0;

    this.source = ContentElement.getSource();
    this.duration = ContentElement.getDuration();
    this.relative_path = ContentElement.relative_path;
    this.path = ContentElement.path;
    this.tag = "";
    this.timer = null;
    this.start_timer = 0;
    this.start_current_time = 0;
    this.youtube = false;
    this.url_youtube = "";

    this.restart_on_activity = false;
    
    //this.content_api = new ApiContentConnector();

    this.update = function(ContentElement){
        self.content = ContentElement;
        self.source = ContentElement.getSource();
        self.duration = ContentElement.getDuration();
        self.relative_path = ContentElement.relative_path;
        self.path = ContentElement.path;
    };
    
    this.createIframe = function(layer){
      try{
        $("#"+self.tag).hide();
        self.clear_source();
      }catch(e){
        self.log("TAG does not exist");
      }
      if(self.platform == "CHROMEOS"){
        $(".stage").append('<webview class="player-media" id="'+self.tag+'" src=""></webview>');
      }else{
        $(".stage").append('<iframe class="player-media" id="'+self.tag+'" src="" sandbox="allow-forms allow-modals allow-orientation-lock allow-pointer-lock allow-presentation allow-same-origin allow-scripts" allowusermedia allow="camera *; microphone *;fullscreen *;autoplay *;geolocation * "></iframe>');
      }
    };

    this.load = function(){
        self.loaded = false;
        self.createIframe();
        self.enable_content_api_events();
        self.log("WARNING : This class is incomplete, security issues may appear.");
        self.loadUrlFromFile(self.path);
        var ext = self.path.substring(self.path.lastIndexOf(".")+1,self.path.length);
        if(ext == "youtube"){
            self.youtube = true;
        }
    };

    this.enable_content_api_events = function(){
        $(self.content_api).off("ApiContentChangeDuration",self.onApiChangeDuration);
        $(self.content_api).on("ApiContentChangeDuration",self.onApiChangeDuration);
        $(self.content_api).off("ApiContentFinish",self.onApiContentFinish);
        $(self.content_api).on("ApiContentFinish",self.onApiContentFinish);
        //$(window).off("UserActivity",self.onUserActivity);
        //$(window).on("UserActivity",self.onUserActivity);
    };


    this.onApiChangeDuration = function(e,command){
        if(typeof(command.params) !== "undefined"){
            if(typeof(command.params.duration) !== "undefined"){
                if(!isNaN(command.params.duration)){
                    self.log("Api Content "+self.tag+" wants to change duration to : "+command.params.duration);
                    clearTimeout(self.timer);
                    self.duration = command.params.duration;
                    self.timer = setTimeout(self.timeout,self.duration*1000);
                    if(typeof(command.params.restart_on_activity) !== "undefined"){
                        self.restart_on_activity = command.params.restart_on_activity;
                        /*
                        if(self.restart_on_activity){
                            $("#"+self.tag).css('pointer-events','none');
                        }
                        */
                    }else{
                        self.restart_on_activity = false;
                    }
                }
            }else{
                self.notifyError(self.ERROR['DISPLAY_WEB_URL_ELEMENT']+4,self.name+": Function onApiChangeDuration() failed : not valid file data");
            }
        }else{
            self.notifyError(self.ERROR['DISPLAY_WEB_URL_ELEMENT']+4,self.name+": Function onApiChangeDuration() failed : not valid file data");
        }
    };

    this.onApiContentFinish = function(e){
         self.log("Api Content wants to finish now ! ");
         self.timeout();
    };

    this.onUserActivity = function(e){
        if(self.restart_on_activity){
            self.log("User activity restarted duration : "+self.duration);
            clearTimeout(self.timer);
            self.timer = setTimeout(self.timeout,self.duration*1000);
        }
    };

    this.loadUrlFromFile = function(url){
        try{
            var xhr = new XMLHttpRequest();
            xhr.open("GET", url+"?"+Date.now(), true);
            xhr.setRequestHeader("Content-Type","text/plain;charset=UTF-8");
            xhr.addEventListener("load", function () {
                if (xhr.status === 200
                || (xhr.status === 0 && self.platform == "WEBOS")
                || (xhr.status === 0 && self.platform == "MAC")
                || (xhr.status === 0 && self.platform == "LINUX")
                || (xhr.status === 0 && self.platform == "TIZEN")
                || (xhr.status === 0 && self.platform == "WIN")
                || (xhr.status === 0 && self.platform == "ANDROID")
                || (xhr.status === 0 && self.platform == "IOS")) {
                    self.loadUrlElement(xhr.response);
                }else{
                    self.notifyError(self.ERROR['DISPLAY_WEB_URL_ELEMENT']+1,self.name+": Function loadUrlFromFile() failed : bad response XMLHttpRequest: "+xhr.status);
                    self.onElementLoadError();
                }
            }, false);
            xhr.addEventListener("progress", function (e) {
                if(e.lengthComputable){
                    var percent = (e.loaded / e.total) * 100;
                    self.log(percent+" % of "+e.total+" bytes");
                }
            }, false);
            xhr.addEventListener("error", function (e) {
                self.notifyError(self.ERROR['DISPLAY_WEB_URL_ELEMENT']+2,self.name+": Function addEventListener.error() failed : "+url);
                self.onElementLoadError();
            }, false);
                xhr.send();
        }catch(e){
            self.log("unexpected error "+url);
        }

    };

    this.loadUrlElement = function(dataUrl){
        if(!self.youtube){
            self.log("Load on tag : "+self.tag);
            $("#"+self.tag).one("load",self.onElementLoadComplete);
            $("#"+self.tag).one("error",self.onElementLoadError);
            $("#"+self.tag).attr("src",dataUrl);
            self.loaded = true;
            $(self).trigger("DisplayElementLoaded");
        }else{
            self.loaded = true;
            // Youtube Adobe Air compatibility
            self.url_youtube = dataUrl.replace("https://www.youtube.com/v/","https://www.youtube.com/embed/");
            $(self).trigger("DisplayElementLoaded");
        }
    };

    this.onElementLoadComplete = function(event){
        if(typeof($("#"+self.tag)) !== "undefined"){
            if(typeof($("#"+self.tag)[0]) !== "undefined"){
                if(typeof($("#"+self.tag)[0].contentWindow) !== "undefined"){
                  try{
                    $("#"+self.tag)[0].contentWindow.addEventListener("mousedown",self.onMouseEvent,false);
                    $("#"+self.tag)[0].contentWindow.addEventListener("mouseup",self.onMouseEvent,false);
                    $("#"+self.tag)[0].contentWindow.addEventListener("mouseclick",self.onMouseEvent,false);
                    $("#"+self.tag)[0].contentWindow.addEventListener("click",self.onMouseEvent,false);
                    $("#"+self.tag)[0].contentWindow.addEventListener("touchstart",self.onTouchEvent,false);
                    $("#"+self.tag)[0].contentWindow.addEventListener("touchend",self.onTouchEvent,false);
                    $("#"+self.tag)[0].contentWindow.addEventListener("keydown",self.onKeyEvent,false);
                    $("#"+self.tag)[0].contentWindow.addEventListener("keyup",self.onKeyEvent,false);
                    $("#"+self.tag)[0].contentWindow.addEventListener("keypress",self.onKeyEvent,false);
                    $("#"+self.tag)[0].contentWindow.addEventListener("message",self.onMessageRecieve,false);
                  }catch(e){
                    console.log(e);
                  }
                }
            }
        }
        //self.playstatus = "STOP";

    };

    this.onElementLoadError = function(event){
        self.disable();
        self.log("Error on tag : "+self.tag);
        self.playstatus = "INVALID";
        self.notifyError(self.ERROR['DISPLAY_WEB_URL_ELEMENT']+3,self.name+": Function onElementLoadError() failed : "+self.path);
        $(self).trigger("DisplayElementError");
    };

    this.disable = function(){
        if(typeof($("#"+self.tag)) !== "undefined"){
            $("#"+self.tag).off("load");
            $("#"+self.tag).off("error");
            $("#"+self.tag).attr("src","");
        }
    };

    this.play = function(){
        //$("#"+self.tag).css('pointer-events','none');
        self.restart_on_activity = false;
        self.log("Play : "+self.reference+" with duration : "+self.duration+" on tag : "+self.tag);
        if(self.duration > 0){
            clearTimeout(self.timer);
            if(self.start_current_time > 0){
              self.duration = self.duration*1000 - self.start_current_time;
              self.duration = parseInt(self.duration/1000);
              self.start_current_time = 0;
              console.log("Start Set new timeout : "+self.duration);
            }
            self.timer = setTimeout(self.timeout,self.duration*1000);
        }
        self.start_timer = new Date().getTime();
        if(self.youtube){
            $("#"+self.tag).attr("src",self.url_youtube);
        }
        $("#"+self.tag).show();
        $("#"+self.tag).css('visibility','visible');
        $(self).trigger("DisplayElementPlay");
        self.uiStartTime = Date.now();
    };

    this.timeout = function(){
        clearTimeout(self.timer);
        self.start_timer = 0;
        if(self.die){
            self.playstatus = "STOP";
            $(self).trigger("DisplayElementFinish");
        }
    };

    this.connect = function(ui){
        /*
        self.ui = ui;
        if(self.ui){
          self.uiTimer = setInterval(self.updateTime,200);
          self.ui.loadVolume();
        }
        */
    };

    this.disconnect = function(){
        /*
        clearInterval(self.uiTimer);
        if(self.ui){
            self.ui.unloadTime();
            self.ui.unloadVolume();
        }
        self.ui = null;
        */
    };

    this.updateTime = function(){
        var current = (Date.now() - self.uiStartTime) / 1000;
        self.ui.loadTime(current,self.duration);
    };

    this.clear_source = function(){
        clearInterval(self.uiTimer);
        if(typeof($("#"+self.tag)) !== "undefined"){
            if(typeof($("#"+self.tag)[0]) !== "undefined"){
                if(typeof($("#"+self.tag)[0].contentWindow) !== "undefined"){
                  try{
                    $("#"+self.tag)[0].contentWindow.removeEventListener("mousedown",self.onMouseEvent);
                    $("#"+self.tag)[0].contentWindow.removeEventListener("mouseup",self.onMouseEvent);
                    $("#"+self.tag)[0].contentWindow.removeEventListener("mouseclick",self.onMouseEvent);
                    $("#"+self.tag)[0].contentWindow.removeEventListener("click",self.onMouseEvent);
                    $("#"+self.tag)[0].contentWindow.removeEventListener("touchstart",self.onTouchEvent);
                    $("#"+self.tag)[0].contentWindow.removeEventListener("touchend",self.onTouchEvent);
                    $("#"+self.tag)[0].contentWindow.removeEventListener("keydown",self.onKeyEvent);
                    $("#"+self.tag)[0].contentWindow.removeEventListener("keyup",self.onKeyEvent);
                    $("#"+self.tag)[0].contentWindow.removeEventListener("keypress",self.onKeyEvent);
                    $("#"+self.tag)[0].contentWindow.removeEventListener("message",self.onMessageRecieve);
                  }catch(e){
                    console.log(e);
                  }
                }
            }
            $("#"+self.tag).attr("src","about:blank");
        }
        try{
          $("#"+self.tag).remove();
          
        }catch(e){
          self.log("TAG does not exist");
        }
    };

    
    
    this.onTouchEvent = function(e){
      self.log("iFrame Touch Event : "+e.type);
      window.dispatchEvent(new TouchEvent(e.type,e));
    };
    this.onMouseEvent = function(e){
      self.log("iFrame Mouse Event : "+e.type);
      window.dispatchEvent(new MouseEvent(e.type,e));
    };
    this.onKeyEvent = function(e){
      self.log("iFrame Key Event : "+e.type);
      window.dispatchEvent(new KeyboardEvent(e.type,e));
    }; 
    
    this.onMessageRecieve = function(e){
      var original = e;
      self.log("API Content Event on "+self.tag+" : "+original.data+" source : "+original.source+" origin : "+original.origin);
      $(window).trigger("ApiContentEvent",[original,self.tag,self]);
      original = null;
    };
    

    // COMMON
    this.vanish = function(){
        $("#"+self.tag).hide();
        $("#"+self.tag).css("z-index","0");
        $("#"+self.tag).css("visibility","hidden");
        $(window).trigger("ApiContentUnregister",[self.tag]);
        self.log("hide on tag : "+self.tag);
        //self.clear_source();
        
    };

    this.destroy = function(time){
        self.loaded = false;
        clearTimeout(self.timer);
        self.disconnect();
        if(typeof(time) === 'undefined'){ time = 0; }
        if(time == 0){
            self.vanish();
            self.clear_source();
        }else{
            setTimeout(function(){
                self.vanish();
                self.clear_source();
            },time);
        }
        self.disable();
        self.log(self.reference+" destroyed ... on tag : "+self.tag);
    };

    this.modifyViewer = function(x,y,w,h,z){
        if(typeof(z) === 'undefined'){z=1;}
        self.x = x;
        self.y = y;
        self.w = w;
        self.h = h;
        self.z = z;
    };

    this.setViewer = function(){
        $("#"+self.tag).css("left",self.x);
        $("#"+self.tag).css("top",self.y);
        $("#"+self.tag).css("width",self.w);
        $("#"+self.tag).css("height",self.h);
        $("#"+self.tag).css("z-index",self.z);
    };

    this.getCurrentTime = function(){
      return new Date().getTime() - self.start_timer;
    };
}
DisplayWebUrlElement.prototype = new SystemController();
