
/* Compatible models:
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 */

function Screen() {
}

Screen.prototype = new BasicScreenController();
Screen.prototype.constructor = Screen();


// Reference to "this" that won't get clobbered by some other "this"
//Screen.prototype.self = this;
Screen.prototype.name = "RLY8_RS232";

/* 
 * Timers use
 * if (timer = * ) it will load if (timer = 0) it won't load
 * Once init is called, timeouts references are stored here
 */
Screen.prototype.timers = {
    power : 1,
    channel : 0,
    schedule : 1
}

Screen.prototype.maxAttempts = {
    power : 1,
    channel : 0,
    schedule : 1
};

/******************************** PORT ********************************/    

//Conf
Screen.prototype.portValues = {
        name : '',
        config : {
                baudRate : 19200,
                dataBits : 8,
                stopBits : 2
        },
        parser : {
            type : 'byteLength' ,
            delimiter : 1
        }   
}


//PROTOTYPING
/******************************** INIT PROTOTYPING ********************************/
Screen.prototype.formatRemoteId = function ( id ) {
    return Buffer.from ( ( "00" + id.toString()).substr(-2) , 'hex');
};

Screen.prototype.loadDriver = function ( platform ) {
    if  ( typeof RS232_driverController !== "function" ){
        eval('eval')(fs.readFileSync('./app/screenDrivers/RS232.js')+'');
    }

    return new RS232_driverController ();
};

Screen.prototype.loadPortValues = function () {} ;


/******************************** STATUS PROTOTYPING ********************************/

Screen.prototype.generatePowerQuerry = function (){
    var command = Buffer.alloc(1);
    command[0] = 91;
    return command;
}

Screen.prototype.translatePowerQuerry = function ( data ){
    this.status.lastCMD = data.toString('ascii');
    //console.log ( new Date() + ' - ' + this.name + ', screen: '+ this.data.id + " : Result check power status: " + this.status.lastCMD );
    data = data[0]; 
    if ( ( data & ( 1 << ( this.data.remote_id -1 ))) > 0 ){
        this.status.power = 0;
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.power = this.maxAttempts.power;
    }else {
        this.status.power = 1;
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.power = this.maxAttempts.power;
    }
    return;
};

Screen.prototype.endPowerQuerry = function (){
    return;
};


/******************************** CHANNEL PROTOTYPING ********************************/

Screen.prototype.generateChannelQuerry = function (){
    var command = Buffer.alloc(1);
    command[0] = 91;
    return command;
};


Screen.prototype.translateChannelQuerry = function ( data ){
    //no channel control
    this.status.lastCMD = data.toString('ascii');
    this.status.channel = 'Unknown';
    this.status.tstamp = Math.floor(new Date().getTime()/1000);
    this.attemptsCounter.channel = this.maxAttempts.channel;
    return;
};

Screen.prototype.endChannelQuerry = function (){};
    
/******************************** SCHEDULE PROTOTYPING ********************************/
Screen.prototype.generateScheduleQuerry  = function (){ return ""; };
Screen.prototype.translateScheduleQuerry = function ( data ){ return; };
Screen.prototype.endScheduleQuerry       = function (){
        this.attemptsCounter.schedule = this.maxAttempts.schedulereturn;
        return;
    };

/******************************** MISC PROTOTYPING ********************************/
Screen.prototype.generateOnQuerry  = function (){
    var command = Buffer.alloc(1);
    command[0] = 100 + 10 + this.data.remote_id;
    return command;
};
Screen.prototype.translateOnQuerry = function ( data ){ return; };


Screen.prototype.generateOffQuerry  = function (){
    var command = Buffer.alloc(1);
    command[0] = 100 + this.data.remote_id;
    return command;
};
Screen.prototype.translateOffQuerry = function ( data ){ return; };


/******************************** FREE COMMAND PROTOTYPING ********************************/
Screen.prototype.generateFreeQuerry  = function ( commandRecived ){
    return commandRecived;
};
Screen.prototype.translateFreeQuerry = function ( data ){ return; };
Screen.prototype.endFreeQuerry      = function (){ return; };



